<bugID>1203167<Summary>Store user-installed search plugins in a JSON file and stop loading [profile]/searchplugins/*.xml</Summary><Description>Once the search cache is no longer optional (bug 1203161), we could use the cache file as the place to store user-installed engines.

We may also want to merge the search-metadata.json and search.json files if that simplifies the code. The file where user engines are stored should have a verification hash, to prevent tampering. There are already several things in search-metadata.json that have such verification hashes; maybe it's time to unify this, and checksum the whole file at once.

Having the user-installed engines stored in a JSON file should let us easily add metadata related to these search plugins, and we should store information about how the engine was installed (eg. website hostname; conversion from an existing .xml file found in the profile while migrating, etc...).</Description></bugID>